//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrPaleVioletRed
#property indicator_width3  3
#property indicator_width4  3
#property strict

//
//
//

input int                Length        = 20;             // Keltner ma period
input ENUM_MA_METHOD     MaMethod      = MODE_SMA;       // Keltner ma method
input ENUM_APPLIED_PRICE Price         = PRICE_CLOSE;    // Keltner ma price
input int                AtrPeriod     = 20;             // Range period
input double             AtrMultiplier = 2.0;            // Range multiplier
enum  enAtrMode
      {
         atr_Rng,                                        // Calculate using range
         atr_Atr                                         // Calculate using ATR
      };
input enAtrMode          AtrMode       = atr_Rng;        // Range calculating mode

double upb[],dnb[],upa[],dna[],trend[];

//
//
//

int OnInit()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,upb,INDICATOR_DATA); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,dnb,INDICATOR_DATA); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,upa,INDICATOR_DATA); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,dna,INDICATOR_DATA); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   SetIndexBuffer(4,trend);
        
   IndicatorShortName("Keltner channel stop("+(string)Length+")");
return(INIT_SUCCEEDED);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i,r,limit=fmin(rates_total-prev_calculated+1,rates_total-1); 

   //
   //
   //
   
   struct keltStruct
     {
        double mid;
        double max;
        double min;
     };
     static keltStruct wrk[];
     static int        wrkSize = -1;
                   if (wrkSize<rates_total) wrkSize = ArrayResize(wrk,rates_total+500);
   
   //
   //
   //
   
   for(i=limit, r=rates_total-i-1; i>=0; i--,r++)
   {
      double atr=0;
      for (int k=0; k<AtrPeriod && (i+k+1)<rates_total; k++)
         if (AtrMode==atr_Atr)
               atr += fmax(high[i+k],close[i+k+1])-fmin(low[i+k],close[i+k+1]);
         else  atr += high[i+k]-low[i+k];
               atr /= AtrPeriod;
               
      wrk[r].mid = iMA(NULL,0,Length,0,MaMethod,Price,i);
      wrk[r].max = wrk[r].mid + atr*AtrMultiplier;
      wrk[r].min = wrk[r].mid - atr*AtrMultiplier;
             
      trend[i]  = (i<rates_total-1) ? (close[i]>wrk[r-1].max) ? 1 : (close[i]<wrk[r-1].min) ? -1 : trend[i+1] : 0;
             if (i<rates_total-1)
             {
                if (trend[i]==-1 && wrk[r].max>wrk[r-1].max) wrk[r].max = wrk[r-1].max;
                if (trend[i]== 1 && wrk[r].min<wrk[r-1].min) wrk[r].min = wrk[r-1].min;
             }                  
      upb[i] = EMPTY_VALUE; dnb[i] = EMPTY_VALUE;
      if (trend[i] ==  1) upb[i] = wrk[r].min; 
      if (trend[i] == -1) dnb[i] = wrk[r].max; 
      upa[i] = (i<rates_total-1) ? (trend[i]!=trend[i+1] && trend[i]== 1) ? upb[i] : EMPTY_VALUE :  EMPTY_VALUE;
      dna[i] = (i<rates_total-1) ? (trend[i]!=trend[i+1] && trend[i]==-1) ? dnb[i] : EMPTY_VALUE :  EMPTY_VALUE;
   }
return(rates_total);
}




